import xbmcgui
import xbmc
import time
import subprocess
import threading
class CountdownThread(threading.Thread):
    def __init__(self, duration):
        super(CountdownThread, self).__init__()
        self.duration = duration
        self._stop_event = threading.Event()

    def run(self):
        for remaining in range(self.duration, 0, -1):
            if self.stopped():
                break
            self.show_notification(remaining)
            time.sleep(1)
        if not self.stopped():
            self.show_notification(0)
            restart_device()

    def stop(self):
        self._stop_event.set()

    def stopped(self):
        return self._stop_event.is_set()

    def show_notification(self, remaining):
        xbmcgui.Dialog().notification("重启安卓倒计时", f"剩余时间：{remaining} 秒")
def start_timer(duration):
    countdown_thread = CountdownThread(duration)
    countdown_thread.start()
    return countdown_thread

def stop_timer(countdown_thread):
    countdown_thread.stop()

# 执行外部命令的函数
def run_external_command(command):
    process = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    output, error = process.communicate()
    return output.decode(), error.decode()
   
 
def restart_device():
    run_external_command("rebootfromnand")
    run_external_command("reboot -f")
    
    
 
if __name__ == '__main__':
        dialog = xbmcgui.Dialog()
        timer = start_timer(10)
        #dialog.ok("计时器", "计时已开始")
        dialog.yesno("计时器", "要停止计时吗？")
        stop_timer(timer)
 
 